package com.qm.export;

import com.qm.utils.HiveJdbcSource;
import com.qm.utils.MysqlJdbcSource;
import org.apache.commons.lang3.StringUtils;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;


/**
 * 将hive表的数据写入到MySQL中
 *
 */
public class HiveToMysql {

    public static void main(String[] args) throws SQLException {

        //System.out.println("开始读取hive中"+args[0]+"表的数据。。。。。。");
        //读取hive表的结构
        HiveJdbcSource hiveJdbcSource = new HiveJdbcSource();
        Connection hiveconn = hiveJdbcSource.getConn();
        Statement hiveStatement = hiveconn.createStatement();

        //读取hive表字段信息
        List<String> allColumns = new ArrayList<String>();
        StringBuilder sb = new StringBuilder();
        ResultSet hiveColResutSet = hiveStatement.executeQuery("describe  " + args[0]);
        if (hiveColResutSet != null) {
            while (hiveColResutSet.next()) {
                String col_name = hiveColResutSet.getString("col_name");
                if(!StringUtils.isBlank(col_name)){
                    sb.append(col_name+",");
                    allColumns.add(col_name);
                }else break;
            }
        }
        String col_sql = sb.substring(0,sb.length() - 1).toString();
        //释放资源
        hiveJdbcSource.closeResultSet(hiveColResutSet);

        ResultSet hiveSet = hiveStatement.executeQuery("select "+col_sql+" from "+args[0]+" where date_time >= '"+args[1]+"' ");
        List<String> inserList = new ArrayList<String>();
        if (hiveSet!=null){
            while (hiveSet.next()){
                String insertSql = "insert into "+args[0]+" values(";
                for (String column : allColumns) {
                    insertSql += "'"+hiveSet.getObject(column).toString()+"'"+",";
                }


                insertSql = insertSql.substring(0, insertSql.length() - 1) +")";
                inserList.add(insertSql);
            }

        }
        //释放hive资源
        hiveJdbcSource.close(hiveSet,hiveStatement,hiveconn);
        System.out.println("写入数据到MySQL的"+args[0]+"表中");
        if(inserList.size() != 0){
            //将hive的数据批量写入到MySQL中
            MysqlJdbcSource mysqlJdbcSource = new MysqlJdbcSource();
            Connection mysqlConn = mysqlJdbcSource.getConn();
            Statement mysqlStat = mysqlConn.createStatement();
            for (String sql : inserList) {
                mysqlStat.executeUpdate(sql);
            }
            System.out.println(args[0]+"表中的数据写入成功，共写入"+inserList.size()+"条数据");
            mysqlJdbcSource.close(null,mysqlStat,mysqlConn);
        }
        System.out.println("数据导入成功。。。。");

    }

}
