package com.qm.utils;


import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.security.UserGroupInformation;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class HiveJdbcSource extends JDBCSource {

    @Override
    public Connection getConn()  {
        try {
            authKrb5();
            Class.forName(PropertiesUtils.getValue("hive.driver"));
            Connection connection = DriverManager.getConnection(PropertiesUtils.getValue("hive.url"),"","");
            return connection;
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
        return null;
    }



    public static void authKrb5()  {
        // 设置jvm启动时krb5的读取路径参数
        System.setProperty("java.security.krb5.conf","/etc/krb5.conf");
        // 配置kerberos认证
        Configuration conf = new Configuration();
        conf.setBoolean("hadoop.security.authorization", true);
        conf.set("hadoop.security.authentication", "kerberos");
        // System.out.println(System.getProperty("java.security.krb5.conf"));
        UserGroupInformation.setConfiguration(conf);
        try {
            UserGroupInformation.loginUserFromKeytab(
                    "hive@QIAOMENG.COM",
                    "/opt/software/kerberos/hive.keytab");
        } catch (IOException e) {
            e.printStackTrace();
        }
        // System.out.println("Succeeded in authenticating through Kerberos!");
    }


}
