package com.qm.utils;

import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.sql.*;
import java.util.Properties;

/**
 * jdbc连接工具类
 */
public abstract class JDBCSource {

    /**
     * 获取jdbc连接
     * @return
     * @throws SQLException
     */
    public abstract Connection getConn() throws ClassNotFoundException;



    /**
     * @Author 徐顺
     * @Description 释放资源Pro版
     * @Param [rs 结果集对象, stmt 执行sql的对象, conn 数据库连接对象]
     * @return void
     **/
    public  void close(ResultSet rs, Statement stmt, Connection conn){
        if(rs != null){
            try {
                rs.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        if(stmt != null){
            try {
                stmt.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        if(conn != null){
            try {
                conn.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }


    /**
     * @Author 徐顺
     * @Description 释放资源Pro版
     * @Param [rs 结果集对象]
     * @return void
     **/
    public  void closeResultSet(ResultSet rs){
        if(rs != null){
            try {
                rs.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }


}
