package com.qm.utils;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class PropertiesUtils {


    private static Properties props = new Properties();

    /* 在类初始化的时候加载配置文件 */
    static {
        // 1.读取配置文件
        InputStream ins = PropertiesUtils.class.getClassLoader().getResourceAsStream("config.properties");
        try {
            // 2.加载配置文件
            props.load(ins);
        } catch (Exception e) {
            throw new RuntimeException(e + "【加载配置文件失败】");
        } finally {
            if (ins != null) {
                try {
                    ins.close();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
        }
    }

    /**
     * 根据给定的key键，读取器对应的值value
     *
     * @param key
     * @return value
     */
    public static String getValue(String key) {
        try {
            return props.getProperty(key) != null ? props.getProperty(key) : "";
        } catch (Exception e) {
            throw new RuntimeException(e + "读取属性【" + key + "】失败");
        }
    }




}
